hdu4403A very hard Aoshu problem 线段树

//给一个长度为大于2小于15的字符串
//在其中间加‘+’或‘=’使得其成为一个等式的方法的个数
//枚举等号位置,暴力搜索加号加的位置
#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std ;
const int maxn = 20;
typedef __int64 ll ;
int ans;
int a[maxn] ,len_a;
int b[maxn] , len_b ;
char str[maxn] , len;
bool judge(int pos)
{
    ll ans_1 = 0 ,ans_2 = 0;
    int pre = 1 ;
    for(int i = 1;i <= len_a;i++)
    {
        ll temp = 0;
        for(int j = pre ; j <= (i == len_a ? pos :a[i]) ; j++)
        temp = temp*10 + str[j - 1] - ‘0‘ ;
        ans_1 += temp ;
        pre = a[i] + 1 ;
    }
    pre = pos + 1 ;
    for(int i = 1;i <= len_b ;i++)
    {
        ll temp = 0 ;
        for(int j = pre ; j <= (i == len_b?len :b[i]) ;j++)
        temp = temp*10 + str[j - 1] - ‘0‘ ;
        ans_2 += temp ;
        pre = b[i] + 1 ;
    }
    return (ans_1 == ans_2);
}
void dfs(int pos , int step)
{
    if(step == (len))
    {
        if(judge(pos))
        ans ++ ;
        return ;
    }
    if(step < pos)
    {
        a[len_a++] = step ;
        dfs(pos , step+1) ;
        len_a--;
    }
    if(step > pos)
    {
        b[len_b++] = step ;
        dfs(pos , step+1) ;
        len_b-- ;
    }
    dfs(pos , step+1) ;
}
int main()
{
    //freopen("in.txt" , "r" , stdin) ;
    while(scanf("%s" ,str))
    {
        if(str[0] == ‘E‘)
        break;
        len = strlen(str) ;
        ans = 0 ;len_a = len_b = 1 ;
        for(int i = 1;i < len ;i++)
        dfs(i , 1) ;
        printf("%d\n" , ans) ;
    }
    return  0 ;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-11-05 22:32:09

hdu4403A very hard Aoshu problem 线段树的相关文章

ZOJ 3686 A Simple Tree Problem(线段树)

A Simple Tree Problem Time Limit: 3 Seconds      Memory Limit: 65536 KB Given a rooted tree, each node has a boolean (0 or 1) labeled on it. Initially, all the labels are 0. We define this kind of operation: given a subtree, negate all its labels. An

hdu 5152 A Strange Problem线段树+欧拉函数

*****************************************BC题解**********************************************************************1003 A Strange Problem 对于操作二,利用公式 当x >= Phi(C), A^x = A ^ (x%Phi(C) + Phi(C)) (mod C) 对于2333333这个模数来说,求18次欧拉函数后就变成了1,所以只需要保存19层第三次操作的加数

spoj IITWPC4F - Gopu and the Grid Problem 线段树

IITWPC4F - Gopu and the Grid Problem no tags Gopu is interested in the integer co-ordinates of the X-Y plane (0<=x,y<=100000). Each integer coordinate contain a lamp, initially all the lamps are in off mode. Flipping a lamp means switching it on if

hdu5107 K-short Problem(线段树+离散化+思维)

题目链接: huangjing 题意:就是给出狠点建筑的坐标和高度,然后给出很多询问,求在这个坐标右下角的第k矮的建筑.. 思路:太弱了我,这个题目从上个星期天就开始看,但是一直不会,所以只能看别人思路,因为那个k小于10,所以左右节点只取前十就可以了,但是我觉得万一不记录完全万一发生丢失怎么办,后来一想sb了,如果左右节点都取前10的话,那么根节点得到的20个值,在排序必定取到了前10啊...言归正传,这道题因为数据范围太大了,前对建筑和询问一起排序,按x从小到大,再按y从小到大,在按建筑优先

hdu 5107 K-short Problem(线段树)

题目链接:hdu 5107 K-short Problem 题目大意:有N个点,M次询问,每次询问点X,Y,K,表示在点集合{(x,y)|x≤X,y≤Y}中高度第K小的值是多少,没有的 话输出-1. 解题思路:线段树,每个节点维护10个高度(因为K最大为10),将询问和点按照x,y的大小排序,从左向右,从下向 上,每次询问就查询[0,idx(y)]即可.注意如果询问和点的位置相同,要先插入点. #include <cstdio> #include <cstring> #includ

bzoj 3489 A simple rmq problem - 线段树

Description 因为是OJ上的题,就简单点好了.给出一个长度为n的序列,给出M个询问:在[l,r]之间找到一个在这个区间里只出现过一次的数,并且要求找的这个数尽可能大.如果找不到这样的数,则直接输出0.我会采取一些措施强制在线. Input 第一行为两个整数N,M.M是询问数,N是序列的长度(N<=100000,M<=200000) 第二行为N个整数,描述这个序列{ai},其中所有1<=ai<=N 再下面M行,每行两个整数x,y, 询问区间[l,r]由下列规则产生(OIER

【CF903G】Yet Another Maxflow Problem 线段树

[CF903G]Yet Another Maxflow Problem 题意:一张图分为两部分,左边有n个点A,右边有m个点B,所有Ai->Ai+1有边,所有Bi->Bi+1有边,某些Ai->Bj有边,每条边都有一定的容量. 先要求你支持两种操作: 1.修改某条Ai->Ai+1的边的容量2.询问从A1到Bm的最大流 n,m<=100000,流量<=10^9 题解:很有思维含量的题. 首先,我们把求最大流变成求最小割.容易发现,我们最多只会割一条Ai->Ai+1的边

hdu 4973 A simple simulation problem.(线段树)

http://acm.hdu.edu.cn/showproblem.php?pid=4973 有两种操作 D l r 将[l,r]区间翻倍 Q l r询问[l,r]中相同数字出现的最多次数 比赛的时候脑子太乱了,没有想到怎么做.发现每次翻倍序列的长度都在变化,区间对应的数也在变,没有思路. 但是静下心来想一想,思路还是挺清晰的. 无论怎么翻倍,序列中的数都是连续的,范围是1~n.可以拿一个数组来记录每个数出现的次数,当更新或询问区间[l,r]时,可以利用其前缀和找到区间[l,r]对应的数字分别是

hud-5475 An easy problem(线段树)

http://acm.hdu.edu.cn/showproblem.php?pid=5475 题意: 原数开始时是1按顺序给你Q个操作,然后其中操作分两种. 1表示将上个操作后的数乘以后面给你的数然后对取余,然后输出结果,2表示除的操作,将现在的数除以指定的先前你所乘上的第几个数 然后对M取模. 思路: 这题用线段树写,断点更新,复杂度是n*(log(n)); 代码: 1 #include<stdio.h> 2 #include<algorithm> 3 #include<i